﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using InfiniTec.Security;
using System.Security.Cryptography;

namespace _.Daten_verschlüsseln
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            byte[] iv;
            int bytesRead;
            byte[] buffer;

            buffer = new byte[32768];
            iv = new byte[16];
            new RNGCryptoServiceProvider().GetBytes(iv);

            if (!File.Exists(txtFile.Text)) MessageBox.Show("Bitte eine Datei auswählen!");
            if (queryCredentialDialog1.ShowDialog(this) == DialogResult.Cancel) return;
            
            SecureStringDecryptor decryptor = new SecureStringDecryptor(queryCredentialDialog1.Password));
            try {

            }
            finally {
                decryptor.Dispose();
            }


            using (SecureStringDecryptor decryptor = new SecureStringDecryptor(queryCredentialDialog1.Password))
            using (Rijndael aes = Rijndael.Create())
            using (ICryptoTransform transform = aes.CreateEncryptor(decryptor.Password, iv))
            using (FileStream input = File.OpenRead(txtFile.Text))
            using (FileStream output = File.OpenWrite(txtNewFile.Text))
            using (CryptoStream stream = new CryptoStream(output, transform, CryptoStreamMode.Write))
            {
                do {
                    bytesRead = input.Read(buffer, 0, buffer.Length);
                    stream.Write(buffer, 0, bytesRead);
                } while (bytesRead != buffer.Length);
            }
        }

        private void btnSearchLoad_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog(this) == DialogResult.Cancel) return;

            txtFile.Text = openFileDialog.FileName;
        }

        private void btnSearchSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog.ShowDialog(this) == DialogResult.Cancel) return;

            txtNewFile.Text = saveFileDialog.FileName;
        }
    }
}