﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using InfiniTec.Security;
using System.Security.Cryptography;

namespace _.Passwörter_abspeichern
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DeriveBytes db;
            byte[] salt;
            RNGCryptoServiceProvider rng;

            if (queryCredentialDialog1.ShowDialog(this) == DialogResult.Cancel) return;

            rng = new RNGCryptoServiceProvider();
            salt = new byte[16];
            rng.GetBytes(salt);

            using (SecureStringDecryptor decryptor = new SecureStringDecryptor(queryCredentialDialog1.Password))
            {
                db = new Rfc2898DeriveBytes(decryptor.Password, salt, 1024);
            }

            lblPassword.Text = Convert.ToBase64String(db.GetBytes(20));
            lblSalt.Text = Convert.ToBase64String(salt);

            db.GetBytes(16);
        }
    }
}